Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3273)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -204,22 +207,24 @@
         ONLY:  dzw, e, heatflux_output_conversion, nc, nr, p, prr, pt,         &
                q, qc, ql, ql_c, ql_v, qr, rho_ocean, s, sa, u, v, vpt, w,      &
-               waterflux_output_conversion
+               waterflux_output_conversion, d_exner
 
     USE averaging,                                                             &
-        ONLY:  e_av, ghf_av, lpt_av, lwp_av, nc_av,     &
-               nr_av,                                                          &
-               ol_av, p_av, pc_av, pr_av, prr_av, pt_av, q_av, qc_av, ql_av,   &
-               ql_c_av, ql_v_av, ql_vp_av, qr_av, qsws_av, qv_av, r_a_av,      &
+        ONLY:  e_av, ghf_av, lpt_av, lwp_av,                                   &
+               ol_av, p_av, pc_av, pr_av, pt_av, q_av, ql_av,                  &
+               ql_c_av, ql_v_av, ql_vp_av, qsws_av, qv_av, r_a_av,             &
                rho_ocean_av, s_av, sa_av, shf_av, ssws_av, ts_av, tsurf_av,    &
                u_av, us_av, v_av, vpt_av, w_av, z0_av, z0h_av, z0q_av
 
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  c_p, lv_d_cp, l_v
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bulk_cloud_model, bcm_3d_data_averaging
+
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_3d_data_averaging
 
-    USE cloud_parameters,                                                      &
-        ONLY:  cp, l_d_cp, l_v, pt_d_t
-
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, average_count_3d, cloud_physics, doav, doav_n,   &
+        ONLY:  air_chemistry, average_count_3d, doav, doav_n,                  &
                land_surface, rho_surface, urban_surface, uv_exposure,          &
                varnamelength
@@ -323,16 +328,4 @@
                 lwp_av = 0.0_wp
 
-             CASE ( 'nc' )
-                IF ( .NOT. ALLOCATED( nc_av ) )  THEN
-                   ALLOCATE( nc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                ENDIF
-                nc_av = 0.0_wp
-
-             CASE ( 'nr' )
-                IF ( .NOT. ALLOCATED( nr_av ) )  THEN
-                   ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                ENDIF
-                nr_av = 0.0_wp
-
              CASE ( 'ol*' )
                 IF ( .NOT. ALLOCATED( ol_av ) )  THEN
@@ -359,10 +352,4 @@
                 pr_av = 0.0_wp
 
-             CASE ( 'prr' )
-                IF ( .NOT. ALLOCATED( prr_av ) )  THEN
-                   ALLOCATE( prr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                ENDIF
-                prr_av = 0.0_wp
-
              CASE ( 'pt' )
                 IF ( .NOT. ALLOCATED( pt_av ) )  THEN
@@ -377,10 +364,4 @@
                 q_av = 0.0_wp
 
-             CASE ( 'qc' )
-                IF ( .NOT. ALLOCATED( qc_av ) )  THEN
-                   ALLOCATE( qc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                ENDIF
-                qc_av = 0.0_wp
-
              CASE ( 'ql' )
                 IF ( .NOT. ALLOCATED( ql_av ) )  THEN
@@ -406,10 +387,4 @@
                 ENDIF
                 ql_vp_av = 0.0_wp
-
-             CASE ( 'qr' )
-                IF ( .NOT. ALLOCATED( qr_av ) )  THEN
-                   ALLOCATE( qr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                ENDIF
-                qr_av = 0.0_wp
 
              CASE ( 'qsws*' )
@@ -532,4 +507,10 @@
 !--             Turbulence closure module
                 CALL tcm_3d_data_averaging( 'allocate', doav(ii) )
+
+!
+!--             Microphysics module quantities
+                IF ( bulk_cloud_model )  THEN
+                   CALL bcm_3d_data_averaging( 'allocate', doav(ii) )
+                ENDIF
 
 !
@@ -654,26 +635,4 @@
              ENDIF
 
-          CASE ( 'nc' )
-             IF ( ALLOCATED( nc_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         nc_av(k,j,i) = nc_av(k,j,i) + nc(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'nr' )
-             IF ( ALLOCATED( nr_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         nr_av(k,j,i) = nr_av(k,j,i) + nr(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
           CASE ( 'ol*' )
              IF ( ALLOCATED( ol_av ) ) THEN
@@ -758,18 +717,7 @@
              ENDIF
 
-          CASE ( 'prr' )
-             IF ( ALLOCATED( prr_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         prr_av(k,j,i) = prr_av(k,j,i) + prr(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
           CASE ( 'pt' )
              IF ( ALLOCATED( pt_av ) ) THEN
-                IF ( .NOT. cloud_physics ) THEN
+                IF ( .NOT. bulk_cloud_model ) THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
@@ -783,6 +731,6 @@
                    DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
-                            pt_av(k,j,i) = pt_av(k,j,i) + pt(k,j,i) + l_d_cp * &
-                                                          pt_d_t(k) * ql(k,j,i)
+                            pt_av(k,j,i) = pt_av(k,j,i) + pt(k,j,i) + lv_d_cp * &
+                                                          d_exner(k) * ql(k,j,i)
                          ENDDO
                       ENDDO
@@ -797,15 +745,4 @@
                       DO  k = nzb, nzt+1
                          q_av(k,j,i) = q_av(k,j,i) + q(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'qc' )
-             IF ( ALLOCATED( qc_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         qc_av(k,j,i) = qc_av(k,j,i) + qc(k,j,i)
                       ENDDO
                    ENDDO
@@ -862,15 +799,4 @@
                             ENDIF
                          ENDDO
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'qr' )
-             IF ( ALLOCATED( qr_av ) ) THEN 
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         qr_av(k,j,i) = qr_av(k,j,i) + qr(k,j,i)
                       ENDDO
                    ENDDO
@@ -1001,9 +927,9 @@
                          m = surf_lsm_h%end_index(j,i)
                          shf_av(j,i) = shf_av(j,i) +                           &
-                                         surf_lsm_h%shf(m) * cp
+                                         surf_lsm_h%shf(m) * c_p
                       ELSEIF ( match_usm )  THEN
                          m = surf_usm_h%end_index(j,i)
                          shf_av(j,i) = shf_av(j,i) +                           &
-                                         surf_usm_h%shf(m) * cp
+                                         surf_usm_h%shf(m) * c_p
                       ENDIF
                    ENDDO
@@ -1265,4 +1191,10 @@
 
 !
+!--          Microphysics module quantities
+             IF ( bulk_cloud_model )  THEN
+                CALL bcm_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF
+
+!
 !--          Land surface quantity
              IF ( land_surface )  THEN
Index: /palm/trunk/SOURCE/surface_coupler.f90
===================================================================
--- /palm/trunk/SOURCE/surface_coupler.f90	(revision 3273)
+++ /palm/trunk/SOURCE/surface_coupler.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3049 2018-05-29 13:52:36Z Giersch
 ! Error messages revised
 ! 
@@ -101,6 +104,6 @@
         ONLY:  pt, rho_ocean, sa, total_2d_a, total_2d_o, u, v
 
-    USE cloud_parameters,                                                      &
-        ONLY:  cp, l_v
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  c_p, l_v
 
     USE control_parameters,                                                    &
@@ -477,5 +480,5 @@
              
              surf_def_h(2)%shf(m) = surf_def_h(2)%shf(m) +                     &
-                                    surf_def_h(2)%qsws(m) * l_v / cp
+                                    surf_def_h(2)%qsws(m) * l_v / c_p
 !
 !--          ...and convert it to a salinity flux at the sea surface (top)
@@ -498,5 +501,5 @@
           j = surf_def_h(2)%j(m)
           surf_def_h(2)%shf(m) = surf_def_h(2)%shf(m) / rho_ocean(nzt,j,i) *   &
-                                 cp / cpw
+                                 c_p / cpw
 
           surf_def_h(2)%usws(m) = surf_def_h(2)%usws(m) / rho_ocean(nzt,j,i)
Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3274)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3271 2018-09-24 08:20:34Z suehring
 ! Comment revised
 ! 
@@ -231,25 +234,21 @@
     USE arrays_3d,                                                             &
         ONLY:  e, kh, nc, nr, pt, q, ql, qc, qr, s, u, v, vpt, w, zu, zw,      &
-               drho_air_zw, rho_air_zw
+               drho_air_zw, rho_air_zw, d_exner
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  g, kappa, lv_d_cp, pi
 
     USE chem_modules,                                                          &
         ONLY:  constant_csflux, nvar
 
-    USE cloud_parameters,                                                      &
-        ONLY:  l_d_cp, pt_d_t
-
-    USE constants,                                                             &
-        ONLY:  pi
-
     USE cpulog
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, cloud_droplets, cloud_physics,                   &
-               constant_heatflux, constant_scalarflux,                         &     
-               constant_waterflux, coupling_mode, g, humidity, ibc_e_b,        &
-               ibc_pt_b, initializing_actions, kappa,                          &
+        ONLY:  air_chemistry, cloud_droplets,                                  &
+               constant_heatflux, constant_scalarflux,                         &
+               constant_waterflux, coupling_mode, humidity, ibc_e_b,           &
+               ibc_pt_b, initializing_actions,                                 &
                intermediate_timestep_count, intermediate_timestep_count_max,   &
-               land_surface, large_scale_forcing, lsf_surf,                    &
-               message_string, microphysics_morrison, microphysics_seifert,    &
+               land_surface, large_scale_forcing, lsf_surf, message_string,    &
                most_method, neutral, passive_scalar, pt_surface, q_surface,    &
                run_coupled, surface_pressure, simulated_time, terminate_run,   &
@@ -264,4 +263,7 @@
 
     USE kinds
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
 
     USE pegrid
@@ -1467,5 +1469,5 @@
 
              ENDDO
-          ELSEIF ( cloud_physics  .OR.  cloud_droplets )  THEN
+          ELSEIF ( bulk_cloud_model  .OR.  cloud_droplets )  THEN
              !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
              DO  m = 1, surf%ns
@@ -1596,9 +1598,9 @@
           k   = surf%k(m)
 
-          IF ( cloud_physics ) THEN
-             surf%pt1(m) = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
+          IF ( bulk_cloud_model ) THEN
+             surf%pt1(m) = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
              surf%qv1(m) = q(k,j,i) - ql(k,j,i)
           ELSEIF( cloud_droplets ) THEN
-             surf%pt1(m) = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
+             surf%pt1(m) = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
              surf%qv1(m) = q(k,j,i) 
           ELSE
@@ -1820,5 +1822,5 @@
              ENDIF
 
-             IF ( cloud_physics  .OR.  cloud_droplets )  THEN
+             IF ( bulk_cloud_model  .OR.  cloud_droplets )  THEN
                !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
                 DO  m = 1, surf%ns   
@@ -1927,5 +1929,5 @@
 !
 !--    If required compute qc* and nc*
-       IF ( cloud_physics  .AND.  microphysics_morrison  .AND.                 &
+       IF ( bulk_cloud_model  .AND.  microphysics_morrison  .AND.              &
             .NOT. surf_vertical )  THEN
           !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
@@ -1953,5 +1955,5 @@
 !
 !--    If required compute qr* and nr*
-       IF ( cloud_physics  .AND.  microphysics_seifert  .AND.                  &
+       IF ( bulk_cloud_model  .AND.  microphysics_seifert  .AND.               &
             .NOT. surf_vertical )  THEN
           !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
@@ -2145,5 +2147,5 @@
 !
 !--       Compute (turbulent) fluxes of cloud water content and cloud drop conc.
-          IF ( cloud_physics  .AND.  microphysics_morrison  .AND.              &
+          IF ( bulk_cloud_model  .AND.  microphysics_morrison  .AND.           &
                .NOT. downward)  THEN
              !$OMP PARALLEL DO PRIVATE( i, j )
@@ -2159,5 +2161,5 @@
 !
 !--       Compute (turbulent) fluxes of rain water content and rain drop conc.
-          IF ( cloud_physics  .AND.  microphysics_seifert  .AND.               &
+          IF ( bulk_cloud_model  .AND.  microphysics_seifert  .AND.            &
                .NOT. downward)  THEN
              !$OMP PARALLEL DO PRIVATE( i, j )
Index: /palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/surface_mod.f90	(revision 3274)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3254 2018-09-17 10:53:57Z suehring
 ! Remove redundant subroutine argument
 ! 
@@ -207,5 +210,5 @@
     USE chem_modules
 
-    USE control_parameters               
+    USE control_parameters
 
     USE indices,                                                               &
@@ -505,4 +508,8 @@
                                                     !< in the domain (required to activiate RTM)
 
+    LOGICAL ::  surf_bulk_cloud_model = .FALSE.                          !< use cloud microphysics
+    LOGICAL ::  surf_microphysics_morrison = .FALSE.                  !< use 2-moment Morrison (add. prog. eq. for nc and qc)
+    LOGICAL ::  surf_microphysics_seifert = .FALSE.                   !< use 2-moment Seifert and Beheng scheme
+
 
     SAVE
@@ -543,5 +550,6 @@
     PUBLIC bc_h, ind_pav_green, ind_veg_wall, ind_wat_win, ns_h_on_file,       &
            ns_v_on_file, surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v,       &
-           surf_usm_h, surf_usm_v, surf_type, vertical_surfaces_exist
+           surf_usm_h, surf_usm_v, surf_type, vertical_surfaces_exist,         &
+           surf_bulk_cloud_model, surf_microphysics_morrison, surf_microphysics_seifert
 !
 !-- Public subroutines and functions
@@ -1090,5 +1098,5 @@
 !
 !--       
-       IF ( cloud_physics .AND. microphysics_morrison)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
           DEALLOCATE ( surfaces%qcs )
           DEALLOCATE ( surfaces%ncs )
@@ -1098,5 +1106,5 @@
 !
 !--       
-       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           DEALLOCATE ( surfaces%qrs )
           DEALLOCATE ( surfaces%nrs )
@@ -1217,5 +1225,5 @@
 !
 !--       
-       IF ( cloud_physics .AND. microphysics_morrison)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
           ALLOCATE ( surfaces%qcs(1:surfaces%ns)   )
           ALLOCATE ( surfaces%ncs(1:surfaces%ns)   )
@@ -1225,5 +1233,5 @@
 !
 !--       
-       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           ALLOCATE ( surfaces%qrs(1:surfaces%ns)   )
           ALLOCATE ( surfaces%nrs(1:surfaces%ns)   )
@@ -1286,5 +1294,5 @@
 !
 !--       
-       IF ( cloud_physics .AND. microphysics_morrison)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
           DEALLOCATE ( surfaces%qcsws )
           DEALLOCATE ( surfaces%ncsws )
@@ -1292,5 +1300,5 @@
 !
 !--       
-       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           DEALLOCATE ( surfaces%qrsws )
           DEALLOCATE ( surfaces%nrsws )
@@ -1358,5 +1366,5 @@
 !
 !--       
-       IF ( cloud_physics .AND. microphysics_morrison)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
           ALLOCATE ( surfaces%qcsws(1:surfaces%ns) )
           ALLOCATE ( surfaces%ncsws(1:surfaces%ns) )
@@ -1364,5 +1372,5 @@
 !
 !--       
-       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           ALLOCATE ( surfaces%qrsws(1:surfaces%ns) )
           ALLOCATE ( surfaces%nrsws(1:surfaces%ns) )
@@ -1473,5 +1481,5 @@
        DEALLOCATE ( surfaces%vpt1 )
 
-       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           DEALLOCATE ( surfaces%qcs )
           DEALLOCATE ( surfaces%ncs )
@@ -1480,5 +1488,5 @@
        ENDIF
 
-       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           DEALLOCATE ( surfaces%qrs )
           DEALLOCATE ( surfaces%nrs )
@@ -1598,5 +1606,5 @@
        ALLOCATE ( surfaces%vpt1(1:surfaces%ns) )
 
-       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           ALLOCATE ( surfaces%qcs(1:surfaces%ns)   )
           ALLOCATE ( surfaces%ncs(1:surfaces%ns)   )
@@ -1605,5 +1613,5 @@
        ENDIF
 
-       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           ALLOCATE ( surfaces%qrs(1:surfaces%ns)   )
           ALLOCATE ( surfaces%nrs(1:surfaces%ns)   )
@@ -2133,5 +2141,5 @@
              IF ( humidity )  THEN
                 surf%qs(num_h)   = 0.0_wp
-                IF ( cloud_physics .AND. microphysics_morrison)  THEN
+                IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
                    surf%qcs(num_h) = 0.0_wp
                    surf%ncs(num_h) = 0.0_wp
@@ -2141,5 +2149,5 @@
 
                 ENDIF
-                IF ( cloud_physics .AND. microphysics_seifert)  THEN
+                IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
                    surf%qrs(num_h) = 0.0_wp
                    surf%nrs(num_h) = 0.0_wp
@@ -2314,9 +2322,9 @@
              IF ( humidity )  THEN
                 surf%qsws(num_h) = 0.0_wp
-                IF ( cloud_physics  .AND.  microphysics_morrison ) THEN
+                IF ( surf_bulk_cloud_model  .AND.  surf_microphysics_morrison ) THEN
                    surf%ncsws(num_h) = 0.0_wp
                    surf%qcsws(num_h) = 0.0_wp
                 ENDIF
-                IF ( cloud_physics  .AND.  microphysics_seifert ) THEN
+                IF ( surf_bulk_cloud_model  .AND.  surf_microphysics_seifert ) THEN
                    surf%nrsws(num_h) = 0.0_wp
                    surf%qrsws(num_h) = 0.0_wp
@@ -2449,5 +2457,5 @@
 !
 !--             Following wall fluxes are assumed to be zero 
-                IF ( cloud_physics .AND. microphysics_morrison)  THEN
+                IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
                    surf%qcs(num_v) = 0.0_wp
                    surf%ncs(num_v) = 0.0_wp
@@ -2456,5 +2464,5 @@
                    surf%ncsws(num_v) = 0.0_wp
                 ENDIF
-                IF ( cloud_physics .AND. microphysics_seifert)  THEN
+                IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
                    surf%qrs(num_v) = 0.0_wp
                    surf%nrs(num_v) = 0.0_wp
Index: /palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- /palm/trunk/SOURCE/swap_timelevel.f90	(revision 3273)
+++ /palm/trunk/SOURCE/swap_timelevel.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -138,4 +141,7 @@
 #endif
 
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bulk_cloud_model, bcm_swap_timelevel
+
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_swap_timelevel 
@@ -148,7 +154,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, cloud_physics, humidity, land_surface,           &
-               microphysics_morrison, microphysics_seifert, neutral, ocean,    &
-               passive_scalar, timestep_count, urban_surface
+        ONLY:  air_chemistry, humidity, land_surface,                          &
+               neutral, ocean, passive_scalar, timestep_count, urban_surface
 
     USE gust_mod,                                                              &
@@ -205,15 +210,11 @@
     IF ( humidity )  THEN
        q = q_p
-       IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-          qc = qc_p
-          nc = nc_p
-       ENDIF             
-       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-          qr = qr_p
-          nr = nr_p
-       ENDIF
     ENDIF
 
     IF ( passive_scalar )  s = s_p             
+
+    IF ( humidity  .AND.  bulk_cloud_model )  THEN
+       CALL bcm_swap_timelevel ( 0 )
+    ENDIF
 
     IF ( land_surface )  THEN
@@ -249,12 +250,4 @@
           IF ( humidity )  THEN
              q => q_1;    q_p => q_2
-             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-                qc => qc_1;    qc_p => qc_2
-                nc => nc_1;    nc_p => nc_2
-             ENDIF
-             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-                qr => qr_1;    qr_p => qr_2
-                nr => nr_1;    nr_p => nr_2
-             ENDIF
           ENDIF
           IF ( passive_scalar )  THEN
@@ -279,12 +272,4 @@
           IF ( humidity )  THEN
              q => q_2;    q_p => q_1
-             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-                qc => qc_2;    qc_p => qc_1
-                nc => nc_2;    nc_p => nc_1
-             ENDIF
-             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-                qr => qr_2;    qr_p => qr_1
-                nr => nr_2;    nr_p => nr_1
-             ENDIF
           ENDIF
           IF ( passive_scalar )  THEN
@@ -300,4 +285,8 @@
     CALL tcm_swap_timelevel ( MOD( timestep_count, 2) )
 
+    IF ( humidity  .AND.  bulk_cloud_model )  THEN
+       CALL bcm_swap_timelevel ( MOD( timestep_count, 2) )
+    ENDIF
+
     IF ( land_surface )  THEN
        CALL lsm_swap_timelevel ( MOD( timestep_count, 2) )
Index: /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3248 2018-09-14 09:42:06Z sward
 ! Minor formating changes
 ! 
@@ -145,5 +148,5 @@
         ONLY:  mean_inflow_profiles, u, v, w
 
-    USE constants,                                                             &
+    USE basic_constants_and_equations_mod,                                     &
         ONLY:  pi
 
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 3273)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -381,5 +384,5 @@
                bc_lr_cyc, bc_ns_cyc, bc_pt_t_val, bc_q_t_val,                  &
                call_psolver_at_all_substeps,  child_domain, cloud_droplets,    &
-               cloud_physics, constant_flux_layer, constant_heatflux,          &
+               constant_flux_layer, constant_heatflux,                         &
                create_disturbances, dopr_n, constant_diffusion, coupling_mode, &
                coupling_start_time, current_timestep_number,                   &
@@ -393,6 +396,5 @@
                intermediate_timestep_count_max,                                &
                land_surface, large_scale_forcing,                              &
-               loop_optimization, lsf_surf, lsf_vert, masks,                   &
-               microphysics_morrison, microphysics_seifert, mid,               &
+               loop_optimization, lsf_surf, lsf_vert, masks, mid,              &
                multi_agent_system_end, multi_agent_system_start,               &
                nesting_offline, neutral, nr_timesteps_this_run, nudging,       &
@@ -441,6 +443,7 @@
                lsf_nesting_offline, lsf_nesting_offline_mass_conservation
 
-    USE microphysics_mod,                                                      &
-        ONLY: collision_turbulence
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, calc_liquid_water_content,                     &
+              collision_turbulence, microphysics_morrison, microphysics_seifert
 
     USE netcdf_data_input_mod,                                                 &
@@ -757,9 +760,9 @@
           IF ( humidity )  THEN
              CALL exchange_horiz( q_p, nbgp )
-             IF ( cloud_physics .AND. microphysics_morrison )  THEN
+             IF ( bulk_cloud_model .AND. microphysics_morrison )  THEN
                 CALL exchange_horiz( qc_p, nbgp )
                 CALL exchange_horiz( nc_p, nbgp )
              ENDIF
-             IF ( cloud_physics .AND. microphysics_seifert )  THEN
+             IF ( bulk_cloud_model .AND. microphysics_seifert )  THEN
                 CALL exchange_horiz( qr_p, nbgp )
                 CALL exchange_horiz( nr_p, nbgp )
@@ -822,9 +825,9 @@
                    CALL exchange_horiz( q, nbgp )
 
-                   IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                   IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
                        CALL exchange_horiz( qc, nbgp )
                        CALL exchange_horiz( nc, nbgp )
                    ENDIF
-                   IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+                   IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
                        CALL exchange_horiz( qr, nbgp )
                        CALL exchange_horiz( nr, nbgp )
@@ -960,5 +963,5 @@
 !
 !--       If required, compute liquid water content
-          IF ( cloud_physics )  THEN
+          IF ( bulk_cloud_model )  THEN
              CALL calc_liquid_water_content
           ENDIF
Index: /palm/trunk/SOURCE/time_integration_spinup.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 3273)
+++ /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -577,5 +580,5 @@
     FUNCTION solar_angle( local_time ) 
 
-       USE constants,                                                          &
+       USE basic_constants_and_equations_mod,                                  &
        ONLY:  pi
       
Index: /palm/trunk/SOURCE/timestep.f90
===================================================================
--- /palm/trunk/SOURCE/timestep.f90	(revision 3273)
+++ /palm/trunk/SOURCE/timestep.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -154,5 +157,5 @@
     USE kinds
 
-    USE microphysics_mod,                                                      &
+    USE bulk_cloud_model_mod,                                                  &
         ONLY:  dt_precipitation
 
